package be.iminds.ilabt.jfed.restapi.json;


import be.iminds.ilabt.jfed.util.GeniUrn;
import be.iminds.ilabt.jfed.util.RFC3339Util;
import be.iminds.ilabt.util.jsonld.test.BasicObjectTestCollection;
import be.iminds.ilabt.util.jsonld.test.ObjectWithIdTestCollection;

import java.net.URL;
import java.sql.Timestamp;

import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.Matchers.equalTo;
import static org.hamcrest.Matchers.is;

public class SpeaksForCredentialTestCollection extends BasicObjectTestCollection< SpeaksForCredential, SpeaksForCredentialBuilder> {
    public SpeaksForCredentialTestCollection() throws Exception {
        super(SpeaksForCredential.class, SpeaksForCredentialBuilder.class);

        SpeaksForCredentialBuilder cred1 = new SpeaksForCredentialBuilder();
        cred1.setCredentialXml("<SPEAKSFOR CREDENTIAL XML HERE>");
        cred1.setExpire(new Timestamp(RFC3339Util.rfc3339StringToDate("2016-11-30T10:00:00Z").getTime()));
        cred1.setSpeaker(new GeniUrn("urn:publicid:IDN+wall2.ilabt.iminds.be:test+user+user2"));
        cred1.setSpeakingFor(new GeniUrn("urn:publicid:IDN+wall2.ilabt.iminds.be+user+user1"));

        all.add(cred1);

        SpeaksForCredentialBuilder cred2 = new SpeaksForCredentialBuilder();
        cred2.setCredentialXml("<SPEAKSFOR CREDENTIAL XML 2 HERE>");
        cred2.setExpire(new Timestamp(RFC3339Util.rfc3339StringToDate("2017-11-30T10:00:00Z").getTime()));
        cred2.setSpeaker(new GeniUrn("urn:publicid:IDN+wall2.ilabt.iminds.be+user+user1"));
        cred2.setSpeakingFor(new GeniUrn("urn:publicid:IDN+example.com+user+user2"));
        all.add(cred2);
    }

    @Override
    public void assertSameDetails(SpeaksForCredential actual, SpeaksForCredential expected) {
        assertThat(actual.getCredentialXml(), is(equalTo(expected.getCredentialXml())));
        assertThat(actual.getExpire(), is(equalTo(expected.getExpire())));
        assertThat(actual.getSpeaker(), is(equalTo(expected.getSpeaker())));
        assertThat(actual.getSpeakingFor(), is(equalTo(expected.getSpeakingFor())));
    }
}
